package records

import (
	oid "git.frostfs.info/TrueCloudLab/frostfs-sdk-go/object/id"
	"github.com/nspcc-dev/neo-go/pkg/io"
)

func DecodeOIDs(data []byte) ([]oid.ID, error) {
	r := io.NewBinReaderFromBuf(data)

	size := r.ReadVarUint()
	oids := make([]oid.ID, size)

	for i := uint64(0); i < size; i++ {
		if err := oids[i].Decode(r.ReadVarBytes()); err != nil {
			return nil, err
		}
	}
	return oids, nil
}
