package tui

import (
	"maps"

	"git.frostfs.info/TrueCloudLab/frostfs-node/cmd/frostfs-lens/internal/schema/common"
)

type Filter struct {
	values  map[string]any
	results map[string]common.FilterResult
}

func NewFilter(values map[string]any) *Filter {
	f := &Filter{
		values:  maps.Clone(values),
		results: make(map[string]common.FilterResult),
	}
	for tag := range values {
		f.results[tag] = common.No
	}
	return f
}

func (f *Filter) Apply(e common.SchemaEntry) *Filter {
	filter := &Filter{
		values:  f.values,
		results: maps.Clone(f.results),
	}

	for tag, value := range filter.values {
		filter.results[tag] = max(filter.results[tag], e.Filter(tag, value))
	}

	return filter
}

func (f *Filter) Result() common.FilterResult {
	current := common.Yes
	for _, r := range f.results {
		current = min(r, current)
	}
	return current
}
